package zero1hd.rhythmbullet.graphics.meshes;

import zero1hd.rhythmbullet.RhythmBullet;

public class CircularVisualizerMesh {
	private int x, y;
	private int componentCount = 2 + 4;
	private float[] verts;
	
	public CircularVisualizerMesh() {
	}
	
	public void applyPositionChanges() {
		verts = new float[calculateVertices(x, y, RhythmBullet.pixels_per_unit) * componentCount];
	}
	
	private void createCircleVertices(int centerX, int centerY, int radius) {
		int x = radius - 1;
		int y = 0;
		int dx = 1;
		int dy = 1;
		int err = dx - (radius << 1);
		
	    while (x >= y)
	    {
	        putVertex(centerX + x, centerY + y);
	        putVertex(centerX + y, centerY + x);
	        putVertex(centerX - y, centerY + x);
	        putVertex(centerX - x, centerY + y);
	        putVertex(centerX - x, centerY - y);
	        putVertex(centerX - y, centerY - x);
	        putVertex(centerX + y, centerY - x);
	        putVertex(centerX + x, centerY - y);

	        if (err <= 0) {
	            y++;
	            err += dy;
	            dy += 2;
	        } else {
	            x--;
	            dx += 2;
	            err += dx - (radius << 1);
	        }
	    }
	}
	
	private int calculateVertices(int centerX, int centerY, int radius) {
		int x = radius - 1;
		int y = 0;
		int dx = 1;
		int dy = 1;
		int err = dx - (radius << 1);
		int vertCount = 0;
	    while (x >= y)
	    {
	    	vertCount += 8;

	        if (err <= 0) {
	            y++;
	            err += dy;
	            dy += 2;
	        } else {
	            x--;
	            dx += 2;
	            err += dx - (radius << 1);
	        }
	    }
	    
	    return vertCount;
	}
	
	private void putVertex(int x, int y) {
		
	}
}
